﻿using System.Windows.Forms.Design;

namespace Bulldozer.Entities
{
    /// <summary>
    /// Класс-сущность "Бульдозер"
    /// </summary>
    public class EntityBulldozer
    {
        /// <summary>
        /// Скорость
        /// </summary>
        public int Speed { get; private set; }
        /// <summary>
        /// Вес
        /// </summary>
        public double Weight { get; private set; }
        /// <summary>
        /// Основной цвет
        /// </summary>
        public Color BodyColor { get; private set; }

        public Color AdditionalColor { get; private set; }

        public Color DopColor { get; private set; }
        /// <summary>
        /// Шаг перемещения бульдозера
        /// </summary>
        public double Step => (double)Speed * 100 / Weight;
        /// <summary>
        /// Конструктор с параметрами
        /// </summary>
        /// <param name="speed">Скорость</param>
        /// <param name="weight">Вес бульдозера</param>
        /// <param name="bodyColor">Основной цвет</param>
        public EntityBulldozer(int speed, double weight, Color bodyColor, Color additionalColor)
        {
            Speed = speed;
            Weight = weight;
            BodyColor = bodyColor;
            AdditionalColor = additionalColor;
        }
    }

    
}

