﻿namespace Bulldozer.Entities
{
    public class EntityBulldozerUpgraded : EntityBulldozer
    {
        /// <summary>
        /// Дополнительный цвет (для опциональных элементов)
        /// </summary>
        public Color DopColor { get; private set; }
        /// <summary>
        ///  Отвал бульдозера
        /// </summary>
        public bool Blade { get; private set; }
        /// <summary>
        ///  Рыхлитель бульдозера
        /// </summary>
        public bool Ripper { get; private set; }
        /// <summary>
        /// Инициализация полей объекта-класса бульдозера с обвесами
        /// </summary>
        /// <param name="speed">Скорость</param>
        /// <param name="weight">Вес автомобиля</param>
        /// <param name="bodyColor">Основной цвет</param>
        /// <param name="dopColor">Дополнительный цвет</param>
        /// <param name="additionalColor">Цвет обвесов</param>
        /// <param name="blade">Отвал бульдозера</param>
        /// <param name="ripper">Рыхлитель бульдозера</param>
        public EntityBulldozerUpgraded(int speed, double weight, Color bodyColor, Color additionalColor, Color dopColor, bool blade, bool ripper) :
        base(speed, weight, bodyColor, additionalColor)
        {
            DopColor = dopColor;
            Blade = blade;
            Ripper = ripper;
        }
    }
}
