﻿using Bulldozer.DrawingObjects;
using Bulldozer.Generics;
using Bulldozer.MovementStrategy;


namespace Bulldozer
{
    public partial class FormBulldozerCollection : Form
    {
        private readonly BulldozersGenericCollection<DrawingBulldozer, DrawingObjectBulldozer> _bulldozers;
        public FormBulldozerCollection()
        {
            InitializeComponent();
            _bulldozers = new BulldozersGenericCollection<DrawingBulldozer,
                DrawingObjectBulldozer>(pictureBoxCollection.Width, pictureBoxCollection.Height);

        }
        private void ButtonAddBulldozer_Click(object sender, EventArgs e)
        {
            FormBulldozer form = new();
            if (form.ShowDialog() == DialogResult.OK)
            {
                if (_bulldozers + form.SelectedBulldozer != null)
                {
                    MessageBox.Show("Объект добавлен");
                    pictureBoxCollection.Image = _bulldozers.ShowBulldozers();
                }
                else
                {
                    MessageBox.Show("Не удалось добавить объект");
                }

            }
        }

        private void ButtonDeleteBulldozer_Click(object sender, EventArgs e)
        {
            if (MessageBox.Show("Удалить объект?", "Удаление", MessageBoxButtons.YesNo, MessageBoxIcon.Question) == DialogResult.No)

            {
                return;
            }
            int pos = Convert.ToInt32(textBox.Text);
            if (_bulldozers - pos != null)
            {
                MessageBox.Show("Объект удален");
                pictureBoxCollection.Image = _bulldozers.ShowBulldozers();
            }
            else
            {
                MessageBox.Show("Не удалось удалить объект");
            }
        }

        private void ButtonUpdateCollection_Click(object sender, EventArgs e)
        {
            pictureBoxCollection.Image = _bulldozers.ShowBulldozers();
        }
    }
}
