﻿using Bulldozer.DrawingObjects;


namespace Bulldozer.MovementStrategy
{
    /// <summary>
    /// Реализация интерфейса IDrawingObject для работы с объектом DrawingBulldozer (паттерн Adapter)
    /// </summary>
    public class DrawingObjectBulldozer : IMoveableObject
    {
        private readonly DrawingBulldozer? _drawingBulldozer = null;
        public DrawingObjectBulldozer(DrawingBulldozer drawingBulldozer)
        {
            _drawingBulldozer = drawingBulldozer;
        }
        public ObjectParameters? GetObjectPosition
        {
            get
            {
                if (_drawingBulldozer == null || _drawingBulldozer.EntityBulldozer == null)
                {
                    return null;
                }
                return new ObjectParameters(_drawingBulldozer.GetPosX, _drawingBulldozer.GetPosY, _drawingBulldozer.GetWidth, _drawingBulldozer.GetHeight);
            }
        }
        public int GetStep => (int)(_drawingBulldozer?.EntityBulldozer?.Step ?? 0);
        public bool CheckCanMove(DirectionType direction) => _drawingBulldozer?.CanMove(direction) ?? false;
        public void MoveObject(DirectionType direction) => _drawingBulldozer?.MoveBulldozer(direction);
    }
}
