﻿using Bulldozer.DrawingObjects;
namespace Bulldozer.MovementStrategy
{
    /// <summary>
    /// Стратегия перемещения объекта в правую нижнюю границу экрана
    /// </summary>
    public class MoveToBorder : AbstractStrategy
    {
        protected override bool IsTargetDestinaion()
        {
            
            var objParams = GetObjectParameters;

            return objParams != null 
                && objParams.ObjectMiddleHorizontal >= FieldWidth 
                && objParams.ObjectMiddleHorizontal - GetStep() <= FieldWidth
                && objParams.ObjectMiddleVertical >= FieldHeight
                && objParams.ObjectMiddleVertical - GetStep() <= FieldHeight;
        }

        protected override void MoveToTarget()
        {
            var objParams = GetObjectParameters;
            if (objParams == null)
            {
                return;
            }

            var diffX = objParams.ObjectMiddleHorizontal - FieldWidth;
            var diffY = objParams.ObjectMiddleVertical - FieldHeight;

            if (Math.Abs(diffX) > GetStep())
            {
                if (diffX > 0)
                {
                    MoveLeft();
                }
                else
                {
                    MoveRight();
                }
            }

            if (Math.Abs(diffY) > GetStep())
            {
                if (diffY > 0)
                {
                    MoveUp();
                }
                else
                {
                    MoveDown();
                }
            }
        }
    }
}
